Bug 73263 - ACCESSIBILITY: cell highlighting invisible to colorblind people. use blue as default and/or make color customizable
Summary: ACCESSIBILITY: cell highlighting invisible to colorblind people. use blue as ...
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Calc (show other bugs)
Version:
(earliest affected)
Inherited From OOo
Hardware: x86 (IA32) All
: medium enhancement
Assignee: Kohei Yoshida
URL:
Whiteboard: target:4.3.0 target:4.2.1
Keywords:
Depends on:
Blocks: a11y
  Show dependency treegraph
 
Reported: 2014-01-03 17:35 UTC by laughingcedar
Modified: 2016-10-25 19:59 UTC (History)
7 users (show)

See Also:
Crash report or crash signature:


Attachments
This is a simulation (using Vischeck) of what it looks like with colorblindness. Cell D12 (where the pointer is) is highlighted with a red box as part of the formula but it hardly shows up. (158.92 KB, image/jpeg)
2014-01-03 17:35 UTC, laughingcedar
Details
multiple cells highlighted with different colors (5.10 KB, image/png)
2014-01-03 20:00 UTC, tommy27
Details

Note You need to log in before you can comment on or make changes to this bug.
Description laughingcedar 2014-01-03 17:35:52 UTC
Created attachment 91464 [details]
This is a simulation (using Vischeck) of what it looks like with colorblindness. Cell D12 (where the pointer is) is highlighted with a red box as part of the formula but it hardly shows up.

When creating a formula in LibreOffice Calc, selecting a cell to use in the formula highlights it with a thin red outline. For most users with colorblindness (~5% of male users), red/black is a very low-contrast pairing. Red looks very similar to brown or black to most people with colorblindness. When working in cells that already have a border, this additional highlighting is nearly invisible. 

I've attached an image that shows how it looks to people with colorblindness (took a screenshot and ran it through Vischeck colorblind-simulation software). Note that the red highlighting is nearly invisible against the existing black border. 

I'd recommend using blue, instead, as blue/black is a universally-distinguishable pairing. Blue may not stand out as much as red to non-colorblind users, but blue will be bright and visible to all users, even people with colorblindness.

LibreOffice seems to use red frequently to highlight things, but red looks pretty much like black to people with colorblindness.

Fedora 19
LibreOffice 4.1.4.2 401(Build:2)
Comment 1 tommy27 2014-01-03 20:00:17 UTC
Created attachment 91470 [details]
multiple cells highlighted with different colors

I understand what you say but consider that when dealing with formulas Calc assigns different colors (not only red) to all the cells that are involved in the formula... see my screenshot. I don't know if these colors can be customized somehow.
Comment 2 tommy27 2014-01-03 20:02:34 UTC
in the above screenshot D10 is blue, D12 is red, D14 is pink and D16 is green.

which colors are causing troubles to colorblind people?

P.S. this color behaviour is inherited from OOo
Comment 3 laughingcedar 2014-01-03 20:19:55 UTC
(In reply to comment #2)
> in the above screenshot D10 is blue, D12 is red, D14 is pink and D16 is
> green.
> 
> which colors are causing troubles to colorblind people?
> 
> P.S. this color behaviour is inherited from OOo

Tommy,
When examining an existing formula -- yes, Calc uses multiple colors. 

When creating a formula for the first time, however, if you choose cells by clicking on them it only uses red. Each cell you click on gets highlighted red in turn.

Click on an empty cell.
Press = to start entering a formula.
Click on another cell to use that value. It gets highlighted red.
Press + to make it a sum
Click on a third cell, and now it gets highlighted red.
....and so on.

There's a good primer on colorblindness at 
jfly.iam.u-tokyo.ac.jp/html/color_blind/text.html

From my experience, the use of red as a highlight color is a very pervasive problem -- we do it a lot, since to non-colorblind people it's very attention-grabbing. Most people with colorblindness have a weak or nonfunctional red cone. Red therefore looks similar to a dark brown or black, which is hardly a highlight (and disappears completely against a black background....).
Comment 4 tommy27 2014-01-03 21:09:50 UTC
I undestand. would it be good for you to have an option to customize that color choice?

set status to NEW. edited summary notes.
Comment 5 laughingcedar 2014-01-03 21:29:49 UTC
(In reply to comment #4)
> I undestand. would it be good for you to have an option to customize that
> color choice?
> 
> set status to NEW. edited summary notes.

Tommy,
Like most FOSS users, I'll never turn down a customization option :) But I'd also recommend sensible defaults that are as accessible as possible. It would be great if LibreOffice defaults to colorblind-accessible color schemes, both for new users and for people using shared computers that aren't customized for them.
 
If you make the default color blue (like the blue that highlights the first cell in your screenshot), it'll be universally visible as a blue highlight. I don't think that will create problems for anyone else, either.

If you (and/or other developers) are interested in making LibreOffice more colorblind-accessible, I can start taking notes on where I discover inaccessible color schemes and compile a list.

-Daniel
Comment 6 tommy27 2014-01-03 21:47:46 UTC
I think that LibO should really do something for colorblind people.
they are 5% of the population which is a minority but they are not so rare.

I'm not a developer but from my point of view it would be easier to obtain a change color option rather than a definitive color change (see my small summary notes edit) since a lot of people likes red and is used to see that color after years and years using the software. 

Do you have experience with MS Office? 
how do they deal with colorblind issues?

I added a couple of developers to CC list; I'd like to hear from them if they think that customizable colors option could be a feasible solution.
maybe as a new feature or extension.

(In reply to comment #5)
> ....
> If you (and/or other developers) are interested in making LibreOffice more
> colorblind-accessible, I can start taking notes on where I discover
> inaccessible color schemes and compile a list.
> 
> -Daniel

sure, go ahead and file different reports for each of them (the first item that I think about is the BASIC module where all strings are painted in red.

i.e.

sub HelloWorld
print "Hello World"
end sub
Comment 7 laughingcedar 2014-01-03 22:49:19 UTC
(In reply to comment #6)
> I'm not a developer but from my point of view it would be easier to obtain a
> change color option rather than a definitive color change (see my small
> summary notes edit) since a lot of people likes red and is used to see that
> color after years and years using the software. 

I'll push back a bit on this point. Long-time users can probably learn to recognize blue as the new highlight color with minimal fuss. People with colorblindness can't see the red, no matter how hard they try. Being able to customize to something you can see is an improvement, but still a barrier compared to having the default be universally-accessible. 


> Do you have experience with MS Office? 
> how do they deal with colorblind issues?

I fired up the VM to check MS Excel 2003 -- they use two strategies:
1) each cell turns a different color, and red is fourth on the list (like checking out existing formulas in Calc, but for formula construction as well, each cell gets outlined with a different color). First up: blue.

but more usefully:
2) they use redundant coding. Color is not the only component of the highlighting. Each highlighted cell gets the "marquee" dancing-dashes highlight while it's the most-recently selected one, and they also use four bold square handles at the four corners of each highlighted cell/range. The handles may be a little less elegant, but even with hard-to-see colors they make it pretty dang obvious.
Comment 8 V Stuart Foote 2014-01-04 14:59:32 UTC
Changing the GUI default selection by-cell from a red to a blue highlight seems a reasonable accommodation and will probably not affect general UX.

Also, seems that by toggling OS into a high contrast Assistive Technology to trigger LibreOffice High Contrast mode, HC mode also uses a red default highlighting for selection by-cell. At the least that should probably be changed.
Comment 9 V Stuart Foote 2014-01-19 17:33:52 UTC
If default 'red' cell selection color can't be adjusted, would we at least be able to implement the "4 bold corner handles" of the selection block as suggested in comment 7?  It looks to be already available for highlighting cells contained in the formula. Could it be reused simply?

@Kohei?
Comment 10 Kohei Yoshida 2014-01-19 18:58:10 UTC
This color is already customizable.

Go to Tools - Options - LibreOffice - Appearance, and look under the Spreadsheet section.  There is a color setting for 'References', which appears to be used for the color for the range mode.

And I have no problem changing the default color to something sensible.

OTOH, the colors for the formula references (as in Comment #1) are hard-coded, and are unrelated to this setting.  You can find the hard-coded color list in sc/source/ui/app/rfindlst.cxx .
Comment 11 Stefan Knorr (astron) 2014-02-03 21:33:03 UTC
I see some software uses purple highlights, like Firefox's Highlight All feature (on Windows it is #EF0FFF). Does that particular colour have any advantages over blue?
I guess the one obvious one is that it is not the default selection colour on most systems, so it should stand out more. But are there other reasons?
Comment 12 V Stuart Foote 2014-02-04 00:44:33 UTC
@Kohei,

To close this out, could we ask you to insert Astron's suggested 0xef0fff, into the default color array aAutoColors[] in colorcfg.cxx

/core/svtools/source/config/colorcfg.cxx

@@ -447,1 +447,1
--        COL_LIGHTRED, // CALCREFERENCE
++        0xef0fff, // CALCREFERENCE

That should be all that is needed to change the default 'automatic' assignment for Calc references from the COL_LIGHTRED (0xff0000) constant from /core/include/tools/color.hxx 

Right? Or did I miss something in the enum in colorcfg.hxx?
Comment 13 Kohei Yoshida 2014-02-04 22:11:46 UTC
(In reply to comment #12)
> @Kohei,
> 
> To close this out, could we ask you to insert Astron's suggested 0xef0fff,
> into the default color array aAutoColors[] in colorcfg.cxx
> 
> /core/svtools/source/config/colorcfg.cxx
> 
> @@ -447,1 +447,1
> --        COL_LIGHTRED, // CALCREFERENCE
> ++        0xef0fff, // CALCREFERENCE
> 
> That should be all that is needed to change the default 'automatic'
> assignment for Calc references from the COL_LIGHTRED (0xff0000) constant
> from /core/include/tools/color.hxx 
> 
> Right? Or did I miss something in the enum in colorcfg.hxx?

Well, you know as much as I do on this matter. ;-)

Anyway, I did change it and it appears to do what we want.  I'll commit this shortly.
Comment 14 Kohei Yoshida 2014-02-04 22:12:08 UTC
I'll take it.
Comment 15 Commit Notification 2014-02-04 22:14:43 UTC
Kohei Yoshida committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=95a7e952552adb834f92d1477f83938e7c8d0204

fdo#73263: Change the default color for reference border to non-red.



The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 16 Kohei Yoshida 2014-02-04 22:17:24 UTC
Backport request for 4.2 is underway: https://gerrit.libreoffice.org/7862
Comment 17 Commit Notification 2014-02-05 08:27:34 UTC
Kohei Yoshida committed a patch related to this issue.
It has been pushed to "libreoffice-4-2":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=08c7fb3a8e952ad03f043c445802b0120a452a15&h=libreoffice-4-2

fdo#73263: Change the default color for reference border to non-red.


It will be available in LibreOffice 4.2.1.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 18 Kohei Yoshida 2014-02-05 14:00:55 UTC
Fixed now.
Comment 19 V Stuart Foote 2014-02-06 18:15:11 UTC
@laughingcedar,

We have adjusted the 'default' color for the selection cell highlighting from a light red (#ff0000), to a deep pink color (#ef0fff)

Additionally as noted, in Calc the default color for the cell highlight can be changed from the Tools --> Options --> Appearance, Custom colors panel in the Spreadsheet section by modifying the 'References' element.

Please take a moment to download and test a current build of the 4.3.0.0alpha+ master from http://dev-builds.libreoffice.org/daily/master/

Satisfactory? Please verify.
Comment 20 laughingcedar 2014-02-06 18:46:15 UTC
You can test-drive it for yourself, too.  Take screenshots (use a spreadsheet with black cell borders, which is where the contrast problems really crop up) and run them through the Vischeck colorblind simulation software:
http://www.vischeck.com/vischeck/vischeckImage.php

The light magenta (#ef0fff) is an improvement over pure red, though not as visible as pure blue (#0000ff) -- except for people with tritanopia which, although rare compared to other forms of colorblindness, makes it impossible to distinguish blue from black. It's a workable compromise.